/* FUZZd PAM/NSS Authenticator by Jeroen Massar <jeroen@unfix.org> */

/* For sanity's sake make a seperate PAM entry for 'fuzzauth' and don't list any reference to fuzzauth in nsswitch.conf
	Though you will make a nice loop if you do...
	
	That's also a reason why this module isn't implemented fully yet -> ENOUSE ;)
	
	What _could_ be the use of this module is for distributing a working PAM config
	on one machine to all the other machines which try to authenticate to the FUZZd running on it.
*/

// FUZZd
#include "fuzzd.h"

// PAM
#include <security/pam_appl.h>

/* NSS */
#include <nss.h>

/* Password & Group */
#include <pwd.h>
#include <grp.h>

/************************
 PAM Conversation
************************/
int PAMNSS_Conversation(int nNumMsg, const struct pam_message **pxMsg, struct pam_response **pxResp, void *xClientA)
{
	int							nRet = PAM_SUCCESS, i;
	struct pam_response		*xResp;
	char							*sText;
	struct Client				*xClient = (struct Client *)xClientA;

	xResp = (struct pam_response *)calloc(nNumMsg, sizeof(struct pam_response));
	for (i = 0; i < nNumMsg; i++)
	{
		if (	pxMsg[i]->msg_style == PAM_PROMPT_ECHO_ON ||
				pxMsg[i]->msg_style == PAM_PROMPT_ECHO_OFF ||
				pxMsg[i]->msg_style == PAM_ERROR_MSG ||
				pxMsg[i]->msg_style == PAM_TEXT_INFO)
		{
			if (pxMsg[i]->msg_style == PAM_PROMPT_ECHO_OFF || pxMsg[i]->msg_style == PAM_PROMPT_ECHO_ON)
			{
				sText = calloc(1, PAM_MAX_MSG_SIZE);
				if (pxMsg[i]->msg_style == PAM_PROMPT_ECHO_ON) strncpy(sText, xClient->m_xPkt_User.m_sUsername, PAM_MAX_MSG_SIZE);
				else strncpy(sText, xClient->m_xPkt_User.m_sPassword, PAM_MAX_MSG_SIZE);
				xResp[i].resp = sText;
			}
		}
		else nRet = PAM_CONV_ERR;
	}
	*pxResp = xResp;
	return nRet;
}

/**************************************
 Authenticate this Client against PAM
**************************************/
bool pamnss_Authenticate(struct Client *xClient)
{
	bool					bRet = false;
	int					nRet, i;
	pam_handle_t		*pamHandle;
	struct pam_conv	pamConversation;

	D(DLOG("[%s] pamnss_Authenticate()", xClient->m_sHostname));
	pamConversation.conv=PAMNSS_Conversation;
	pamConversation.appdata_ptr=xClient;
	nRet = pam_start(FUZZAUTH_NAME, NULL, &pamConversation, &pamHandle);
	if (nRet == PAM_SUCCESS)
	{
		nRet = pam_authenticate(pamHandle, 0);
		if (nRet == PAM_SUCCESS) bRet = true;	
		else fuzzd_Log(LOG_ERR, "[%s] pam_Authenticate(): ERROR: pam_authenticate() %d %s.\n", xClient->m_sHostname, nRet, pam_strerror(pamHandle, nRet));
	}
	else bRet = false;
	pam_end(pamHandle, 0);
	return bRet;
}

/**************************************
 Change Password
**************************************/
bool pamnss_ChangePassword(struct Client *xClient)
{
	THIS CODE IS NOT IMPLEMENTED YET!!!!!
	return false;
}

/****************************
 Get Users from our backend.
****************************/
bool pamnss_GetUsers(struct Client *xClient)
{
	bool bRet = false;
	THIS CODE IS NOT IMPLEMENTED YET!!!!!

	xClient->m_xPkt_Answer.m_nAnswer = c_nAnswer_Granted;
	bRet = ReturnAnswer(xClient, c_nDatatype_User);
	// Get the next one... and so on...

	// This one will be send by the mainloop.
	xClient->m_xPkt_Answer.m_nAnswer = c_nAnswer_NoMoreData;
	return bRet;
}

/****************************
 Match User by UserID
****************************/
bool pamnss_MatchUserID(struct Client *xClient)
{
	THIS CODE IS NOT IMPLEMENTED YET!!!!!
	return false;
}

/****************************
 Match Group by name
****************************/
bool pamnss_MatchUserName(struct Client *xClient)
{
	THIS CODE IS NOT IMPLEMENTED YET!!!!!
	return false;
}

/*****************************
 Get Groups from our backend.
*****************************/
bool pamnss_GetGroups(struct Client *xClient)
{
	bool bRet = false;
	
	THIS CODE IS NOT IMPLEMENTED YET!!!!!
	
	xClient->m_xPkt_Answer.m_nAnswer = c_nAnswer_Granted;
	bRet = ReturnAnswer(xClient, c_nDatatype_Group);

	// This one will be send by the mainloop.
	xClient->m_xPkt_Answer.m_nAnswer = c_nAnswer_NoMoreData;
	return bRet;
}

/****************************
 Match Group by GroupID
****************************/
bool pamnss_MatchGroupID(struct Client *xClient)
{
	THIS CODE IS NOT IMPLEMENTED YET!!!!!
	return false;
}

/****************************
 Match Group by name
****************************/
bool pamnss_MatchGroupName(struct Client *xClient)
{
	THIS CODE IS NOT IMPLEMENTED YET!!!!!
	return false;
}
