/*	FUZZauth - http://unfix.org/projects/fuzzauth & http://fuzzauth.sourceforge.net
 * FUZZauthadmin - FUZZauth Command-line Client by Jeroen Massar <jeroen@unfix.org>
 *
 *	First this was used for testing the fuzzauth_common functions and it was called fuzzauthclient.
 * Now it is the commandline interface for the Add/Remove/Change User/Group/Member functions.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdarg.h>
#include <sys/types.h>

/* FUZZauth */
#include "fuzzauth.h"
#include "fuzzauth_common.h"

#ifndef bool
#define bool int
#endif
#ifndef false
#define false 0
#endif
#ifndef true
#define true (!false)
#endif

/************************
 Globals
************************/
volatile bool g_bQuit = false;

/************************
 User
************************/
//	printf(" add    user <username> <password> <primarygroupname/id> <gecos> <homedir> [<shell>]>\n");
//	printf("        group <groupname> [<password>]\n");
//	printf("        member <username/id> <groupname/id>\n");
int UserShow(int nArgc, char **psArgv)
{
	//fuzzauth_UserShow()
	return -1;
}

int UserAdd(int nArgc, char **psArgv)
{
	int nRet = -1;
	if (nArgc == 9) nRet = fuzzauth_UserAdd(psArgv[3], psArgv[4], psArgv[5], psArgv[6], psArgv[7], psArgv[8]) ? 0 : -1;
	return nRet;
}

int UserRemove(int nArgc, char **psArgv)
{
	int nRet = -1;
	if (nArgc == 4) nRet = fuzzauth_UserRemove(psArgv[3]);
	return nRet;
}

int UserChange(int nArgc, char **psArgv)
{
	return -1;
}

/************************
 User
************************/
int GroupShow(int nArgc, char **psArgv)
{
	return -1;
}

int GroupAdd(int nArgc, char **psArgv)
{
	int nRet = -1;
	if (nArgc == 5) nRet = fuzzauth_GroupAdd(psArgv[3], psArgv[4]) ? 0 : -1;
	return nRet;
}

int GroupRemove(int nArgc, char **psArgv)
{
	int nRet = -1;
	if (nArgc == 4) nRet = fuzzauth_GroupRemove(psArgv[3]);
	return nRet;
}

int GroupChange(int nArgc, char **psArgv)
{
	return -1;
}

/************************
 Member
************************/
int MemberAdd(int nArgc, char **psArgv)
{
	int nRet = -1;
	if (nArgc == 5) nRet = fuzzauth_MemberAdd(psArgv[3], psArgv[4]);
	return nRet;
}

int MemberRemove(int nArgc, char **psArgv)
{
	int nRet = -1;
	if (nArgc == 5) nRet = fuzzauth_MemberRemove(psArgv[3], psArgv[4]);
	return nRet;
}

/************************
 Usage
************************/
void Usage(char *sProgname)
{
	printf("%s Admin by %s <%s>\r\n", FUZZAUTH_NAME, FUZZAUTH_AUTHOR, FUZZAUTH_EMAIL);
	printf("%s <show|add|remove|change> [<args>]\n", sProgname);
	printf(" show   <user|group> [<name>]\n");
	printf(" add    user <username> <password> <primarygroupname/id> <gecos> <homedir> [<shell>]>\n");
	printf("        group <groupname> [<password>]\n");
	printf("        member <username/id> <groupname/id>\n");
	printf(" remove user <username/id>\n");
	printf("        group <groupname/id>\n");
	printf("        member <username/id> <groupname/id>\n");
	printf(" change user <username/id> <newusername> <password> <primarygroupname/id> <gecos> <homedir> [<shell>]>\n");
	printf("        group <groupname/id> <newgroupname> [<password>]\n");
	g_bQuit = true;
}

/* Global items */
int main(int nArgc, char **psArgv)
{
	int nRet = 0;
	
	if (nArgc >= 3)
	{
		if (strcasecmp(psArgv[1], "show") == 0)
		{
			if      (strcasecmp(psArgv[2], "user")		== 0)	nRet = UserShow(nArgc, psArgv);
			else if (strcasecmp(psArgv[2], "group")	== 0)	nRet = GroupShow(nArgc, psArgv);
			else Usage(psArgv[0]);
		}
		else if (strcasecmp(psArgv[1], "add") == 0)
		{
			if      (strcasecmp(psArgv[2], "user")		== 0)	nRet = UserAdd(nArgc, psArgv);
			else if (strcasecmp(psArgv[2], "group")	== 0)	nRet = GroupAdd(nArgc, psArgv);
			else if (strcasecmp(psArgv[2], "member")	== 0)	nRet = MemberAdd(nArgc, psArgv);
			else Usage(psArgv[0]);
		}
		else if (strcasecmp(psArgv[1], "remove") == 0)
		{
			if      (strcasecmp(psArgv[2], "user")		== 0)	nRet = UserRemove(nArgc, psArgv);
			else if (strcasecmp(psArgv[2], "group")	== 0)	nRet = GroupRemove(nArgc, psArgv);
			else if (strcasecmp(psArgv[2], "member")	== 0)	nRet = MemberRemove(nArgc, psArgv);
			else Usage(psArgv[0]);
		}
		else if (strcasecmp(psArgv[1], "change") == 0)
		{
			if      (strcasecmp(psArgv[2], "user")		== 0)	nRet = UserChange(nArgc, psArgv);
			else if (strcasecmp(psArgv[2], "group")	== 0)	nRet = GroupChange(nArgc, psArgv);
			else Usage(psArgv[0]);
		}
		else Usage(psArgv[0]);

/*
		char	sUsername[100], *sPassword;
		printf("Authentication check:\n");
		printf("Username: ");
		fflush(stdout);
		if ((fgets(sUsername, sizeof(sUsername)-1, stdin) == sUsername) && (strlen(sUsername) > 0))
		{
			sUsername[strlen(sUsername)-1] = '\0';
			fflush(stdout);
			sPassword = getpass("Password: ");
			if (strlen(sPassword) > 0)
			{
				sPassword[strlen(sPassword)-1] = '\0';
				printf("Authenticating %s...", sUsername);
				fflush(stdout);
				if (fuzzauth_Authenticate(sUsername, sPassword))
				{
					printf("Access Granted\n");
					nRet = 0;
				}
				else
				{
					printf("Access Denied\n");
					nRet = 1;
				}
			}
			else printf("Aborting...\n");
		}
		else printf("Aborting...\n");
*/
	}
	else Usage(psArgv[0]);
	return nRet;
}
