#ifndef COMMON_H
#define COMMON_H "FUZZauth"

#ifndef bool
#define bool int
#endif
#ifndef false
#define false 0
#endif
#ifndef true
#define true (!false)
#endif


/* Node of a list. */
struct node
{
	struct node	*next;			   			/* Next. */
	struct node	*prev;			   			/* Previous. */
	void			*data;							/* Data. */
};

/* List structure. */
struct list
{
	struct node *next;		   				/* Next/First in list. */
	struct node *prev;							/* Previous in list (Always NULL). */
	struct node *tail;							/* Last node (Tail) in the list. */
};

void				lst_New(struct list *lst);
bool				lst_AddHead(struct list *lst,void *data);
bool				lst_AddTail(struct list *lst,void *data);
void				lst_RemNode(struct node *nod);
struct node		*lst_GetFirst(struct list *lst);
struct node		*lst_GetNext(struct node *nod);
void				*lst_GetData(struct node *nod);

#ifdef DEBUG
void				lst_Debug(struct list *lst,char *func);
void				lst_DebugNode(struct node *node,char *func);
#else
#define lst_Debug(x,y)	;
#define lst_DebugNode(x,y)	;
#endif
#define lst_IsEmpty(lst) (NULL==(lst)->next->next)
#define lst_RemHead(lst) lst_RemNode(lst->next)
#define lst_RemTail(lst) lst_RemNode(lst->tail)

#ifndef NULL
#define NULL 0
#endif

#endif // ifndef COMMON_H
